<% if (section === 'css') { %>
<style>
  :root {
    --marquee-pos: 100%;
    --marquee-duration: 10s;
  }

  .start-body {
    position: absolute;
    width: 100%;
    height: 85%;
  }

  #footer {
    position: absolute;
    width: 100%;
    height: 15%;
    top: 85%;
    overflow: hidden;
    box-sizing: border-box;
    color: black;
  }

  @keyframes marquee {
    from {left: 100%;}
    to {left: var(--marquee-pos);}
  }

  #footer-text {
    left: 100%;
    display: inline-flex;
    position: relative;
    white-space: nowrap;
    animation-name: marquee;
    animation-duration: var(--marquee-duration);
    animation-iteration-count: infinite;
    animation-timing-function: linear;
    line-height: 1.5;
  }

  .sponsor-page {
    position: absolute;
    width: 100%;
    height: 85%;
    opacity: 0;
    transition: opacity 2s linear;
    display: flex;
    flex-direction: row;
    flex-wrap: nowrap;
  }

  .sponsor-page > div {
    background-color: #2D4082;
    border-radius: 50%;
    flex: 1 0 auto;
    justify-content: space-around;
    aspect-ratio: 1 / 1;
    margin-left: 5px;
    margin-right: 5px;

    display: flex;
    flex-direction: column;
    align-content: center;
  }

  .sponsor-page > div > img {
    max-height: 90%;
    max-width: 90%;
    margin-left: auto;
    margin-right: auto;
  }


</style>
<% } %>

<% if (section === 'html') { %>
<div class="page" page="start">
  <div id="custom-text" class="text-fit start-body"></div>
  <div id="sponsor-block" class="start-body"></div>
  <div id="footer" align="left">
    <div id="footer-text">
      <span id="latest-waterpolo-matches"></span>
    </div>
  </div>
</div>
<% } %>

<% if (section === 'js') { %>
<script>
  const root = document.documentElement;

  registerCommand('start', 'data', (data) => {
    const sponsorsEnabled = data.sponsorsEnabled;

    const customText = document.getElementById('custom-text')
    const sponsorBlock = document.getElementById('sponsor-block')

    customText.style.opacity = sponsorsEnabled ? 0 : 1
    sponsorBlock.style.opacity = sponsorsEnabled ? 1 : 0

    if (!sponsorsEnabled) {
      customText.innerHTML = data.customText.replace(/\n/g, '<br>')
      customText.style.textAlign = data.customTextAlignment
      fitText(customText)
    } else {
      setSponsorData(data.sponsorData)
    }

    document.getElementById('latest-waterpolo-matches').innerHTML = data.latestWaterpoloMatches
    calcMarqueeSpeed()

    window.addEventListener('resize', () => {
        calcMarqueeSpeed()
    })
  })

  function setSponsorData(data) {
    const sponsorsPerPage = 3
    const sponsorBlock = document.getElementById('sponsor-block')

    // Clear existing data
    sponsorBlock.innerHTML = ''

    const numOfPages = Math.ceil(data.length / sponsorsPerPage)

    for (let pageIndex = 0; pageIndex < numOfPages; pageIndex++) {
      const page = document.createElement('div')
      page.className = 'sponsor-page'

      for (let sponsorIndex = 0; sponsorIndex < sponsorsPerPage; sponsorIndex++) {
        const sponsorNum = (pageIndex * sponsorsPerPage) + sponsorIndex;

        // Create image container
        const container = document.createElement('div')
        page.appendChild(container)

        // Create image
        const img = new Image()
        if (sponsorNum < data.length)
          img.src = `data:image/png;base64,${data[pageIndex * sponsorsPerPage + sponsorIndex].logo}`
        else if (sponsorNum === data.length)
          img.src = "media/uw_logo_hier.png";
        else
          img.src = "media/neem_contact_op.png";

        container.appendChild(img)
      }

      sponsorBlock.appendChild(page)
    }
    
    clearInterval(sponsorPageInterval)

    changeSponsorPage()
    sponsorPageInterval = setInterval(changeSponsorPage, 10 * 1000)
  }

  // Sponsor stuff
  let sponsorPageIndex = 0, sponsorPageInterval

  function changeSponsorPage() {
    const pages = document.getElementsByClassName('sponsor-page')

    // Hide current page
    pages[sponsorPageIndex].style.opacity = 0

    sponsorPageIndex++
    if (sponsorPageIndex >= pages.length ) { sponsorPageIndex = 0 }

    // Show next page
    pages[sponsorPageIndex].style.opacity = 1
  }

  // Marquee stuff
  const footer = document.getElementById('footer')
  const footerText = document.getElementById('footer-text')

  function calcMarqueeSpeed() {
    footerText.style.fontSize = footer.offsetHeight / 1.3 + 'px'
    const speed = footer.offsetHeight * 1.5
    const spanLength = footerText.offsetWidth
    const marqueeTime = (spanLength + document.body.offsetWidth) / speed

    root.style.setProperty('--marquee-pos', -spanLength + 'px')
    root.style.setProperty('--marquee-duration', marqueeTime + 's')

    console.log(`Set the footer speed to: ${marqueeTime}s`)
  }
</script>
<% } %>
